#define _XTAL_FREQ 16000000
#include <xc.h>
#define MAIN_C
#include "config_words.h"
#include "christmas-lights.h"

unsigned char effect = 1; // 0 = off, 1-x - effects
volatile unsigned char pwm1Value;
unsigned char timer0PostScaller;
unsigned char timer0PassCounter;
unsigned char pwm3Value;
unsigned char pwm4Value;
unsigned char timerAdd;
unsigned char currentProgram;
unsigned char pwmMin;
unsigned char pwmMax;
flags_t flags;
unsigned char sec8 = 1;
unsigned char sec = 0;
unsigned char progRotate;
unsigned char *runningProgram;

pattern_32_t pattern1;
pattern_32_t pattern3;
pattern_32_t pattern4;


typedef struct{
		unsigned short PWMDC;
		unsigned char PWMCON;
} pwmReg_t;
pwmReg_t pwmReg[3] @0x611;


// pass low byte
void setPwm(unsigned char pwmCon, unsigned char pwmValue){
	union{
		struct{
			unsigned char B0;
			unsigned char B1;
		};
		unsigned short W;
	} word;
	word.B0 = 0;
	word.B1 = pwmValue;
	word.W >>= 2;


	pwmCon--;
	pwmReg[pwmCon].PWMDC = word.W;
}


void init(){
	//INTCONbits.GIE = 0; // disable interrupts

	timer0PostScaller = 5;
	// IO setup

	// RA0 - IN
	// RA1 - IN
	// RA2 - OUT - PWM
	// RA3 - IN - button
	// RA4 - OUT - PWM
	// RA5 - OUT - PWM
	TRISA = 0x0B; // 0000 1011
	ANSELA = 0; // all pins are digital
	WPUA = 0x08; // pull up on RA3
    OPTION_REGbits.nWPUEN = 1;


	// PWM setup
	//PWM_TRIS = 1; // disable output driver

#define PWM_COM_SETUP (_PWM1CON_PWM1EN_MASK | _PWM1CON_PWM1OE_MASK \
              | _PWM1CON_PWM1OUT_MASK) & ~_PWM1CON_PWM1POL_MASK
	// PWMCON
	//PWM1CON = 0;
	//PWM3CON = 0;
	//PWM4CON = 0;
	PR2 = 0x3F; // period
/*
    T2CONbits.TMR2ON = 0;
    T2CONbits.T2OUTPS = 0;
    T2CONbits.T2CKPS = 0;
*/
	T2CON = 0;
	PWM1CON = PWM_COM_SETUP;
	PWM3CON = PWM_COM_SETUP;
	PWM4CON = PWM_COM_SETUP;
    T2CONbits.TMR2ON = 1;


	//timer0
	//OPTION_REGbits.TMR0CS = 0;
	//OPTION_REGbits.PSA = 0;
	//OPTION_REGbits.PS = 0;
	OPTION_REG = 0;

	// timer 1
	T1CON = 0x31;	// 0011 0001


/*
	INTCONbits.PEIE = 1;
	INTCONbits.TMR0IE = 1;
	INTCONbits.INTE = 0;
	INTCONbits.IOCIE = 0;
	INTCONbits.GIE = 1; // enable interrupts
*/
	PIE1 = 0x01; // 0000 0001 - TMR1IE = 1
	PIE2 = 0x00; // 0000 0000
	PIE3 = 0x00; // 0000 0000
	INTCON = 0xE0; // 1110 0000
	//INTCON = 0; // disable interrupts for debugging
	//INTCONbits.GIE = 1; // enable interrupts
}
void delay200ms(void){
	__delay_ms(200);
}

void rotateValue(unsigned char *x, unsigned char overflowValue){
	++(*x);
	if(*x > 7){
		*x = overflowValue;
	}
}
void main(void){
	//OSCCONbits.IRCF = 0xF; // 1111 = 16MHz
	//OSCCONbits.SCS = 3; // internal clock
	OSCCON = 0x7B; // 0111 1011
	init();
	flags.all = 0;

	runningProgram = &progRotate;
	currentProgram = 0;
	progRotate = 1;
	initProgram();
	flags.unpressDebounce = 1;
	while(1){
		if(flags.unpressDebounce){
			if(PORTAbits.RA3){
				// if button is unpressed - put a delay to ignore noise
				flags.unpressDebounce = 0;	
				delay200ms(); // debounce button press
			}
		}else{
			if(!PORTAbits.RA3){
				// button pressed
				flags.changeProgram = 1;
				flags.pressDebounce = 1;

				
			}
		}
		if(flags.rotateProgram){
			flags.rotateProgram = 0;
			// increases progRotate and sets it back to 1 when
			// it goes over 7
			rotateValue(&progRotate, 1);
	
			initProgram();
		}
		if(flags.changeProgram){
			flags.changeProgram = 0;
			// increases progRotate and sets it back to 1 when
			// it goes over 7
			rotateValue(&currentProgram, 0);
			if(currentProgram == 0){
				progRotate = 1;
				runningProgram = &progRotate;
			}else{
				runningProgram = &currentProgram;
			}
			initProgram();
		}
		if(flags.pressDebounce){
			flags.unpressDebounce = 1;
			flags.pressDebounce = 0;
			delay200ms(); // debounce button press
		}
	}

}
