#ifndef CHRISTMAS_LIGHTS_H
#define CHRISTMAS_LIGHTS_H

#include "config.h"

typedef union{
	struct{
		unsigned changeProgram:1;
		unsigned pressDebounce:1;
		unsigned unpressDebounce:1;
		unsigned rotateProgram:1;
	};
	unsigned char all;
} flags_t;

typedef union {
	struct{
		unsigned bit0:1;
		unsigned bit1:1;
		unsigned bit2:1;
		unsigned otherBits:5;
		unsigned lastBits:8;
	};
	struct{
		unsigned char byte0;
		unsigned char byte1;
	};
	unsigned short W;
} pattern16_t;

typedef union {
	struct{
		unsigned bit0:1;
		unsigned bit1:1;
		unsigned bit2:1;
		unsigned otherBits:5;
		unsigned char byte1;
		unsigned char byte2;
		unsigned char byte3;
	};
	struct{
		unsigned short word0;
		unsigned short word1;
	};
	unsigned long DW;
} pattern_32_t;


#ifndef MAIN_C
extern volatile unsigned char pwm1Value;
extern unsigned char pwm3Value;
extern unsigned char pwm4Value;
extern unsigned char timerScale;
extern unsigned char currentProgram;
extern unsigned char timer0PostScaller;
extern unsigned char timer0PassCounter;
extern pattern_32_t pattern1;
extern pattern_32_t pattern3;
extern pattern_32_t pattern4;
extern flags_t flags;
extern unsigned char pwmMin;
extern unsigned char pwmMax;
extern unsigned char sec8;
extern unsigned char sec;
extern unsigned char progRotate;
unsigned char *runningProgram;
#endif // MAIN_C

void setPwm(unsigned char pwmCon, unsigned char pwmValue);
void rotatePatterns(void);
void initProgram(void);
void runProgram(void);

void program1Init(void);
void program1(void);
void program2Init(void);
void program2(void);
void program3Init(void);
// cheat to save program memory
#define program3 program2
void program4Init(void);
void program4(void);
void program5Init(void);
void program5(void);
void program6Init(void);
void program6(void);
void program7Init(void);
void program6(void);
#define program7 program6

#endif //CHRISTMAS_LIGHTS_H