#include <xc.h>

#include "christmas-lights.h"


// Timer 1 interrupt occurs once every 0.1s
void timer1Int(void){
	TMR1L+=223;
	TMR1H+=11;
	if(sec8 == 0){
		sec8 = 8;
		++sec;
		if(sec == PROGRAM_CHANGE_TIME){
			sec = 0;
			if(currentProgram == 0)
				flags.rotateProgram = 1;
		}
	}
	--sec8;

	PIR1bits.TMR1IF = 0;
}

void timer0Int(void){
	if(timer0PassCounter == 0){
		timer0PassCounter = timer0PostScaller;
	}
	--timer0PassCounter;
	if(timer0PassCounter == 0){
		runProgram();
	
		setPwm(1, pwm1Value);
		setPwm(3, pwm3Value);
		setPwm(4, pwm4Value);
	}
	INTCONbits.TMR0IF = 0;
}

void interrupt intHandler(void){
	if(PIR1bits.TMR1IF == 1)
		timer1Int();
	if(INTCONbits.TMR0IF == 1)
		timer0Int();
}
